<?
// sensor.pl
$GBL = null;
$in = null;
GetVars($in);

// *** Define agent version
$GBL['VERSION'] = "2.0.0";
// *** Get the short host name
$GBL['myhostname'] = trim(`hostname`);



if( isset($in['int']) )
	{
	$GBL['snort_pidfile'] = "/var/run/snort_" . $in['int'] . ".pid";
	}

if( isset($in['sw_X']) )
	{
	$GBL['barn_pidfile'] = $in['sw_X'];
	}



// ************************************ snort.conf ********************************************
if( $in['ac'] == "save_snort" )
	{

	// *** Get # of bytes received
	$received = strlen($in['content']);

	// *** Generate filename
	$destfile = $in['path'] . "/SMS_snort." . $in['int'] . ".conf"; 

	// *** Write the contents to the file
	WriteFile($destfile,$in['content']);

	// *** Get the # of bytes written to the file
	$filesize = filesize($destfile);

	// *** Send confirm message
	if ( $filesize <> $received )
        	{
		print"[".$GBL['myhostname']."] ERROR: Receive snort config FAILED.\n";
		return;
		}

	// *** Update the MD5 checksum 
        $md5_file = $destfile . ".MD5";



	WriteFile($md5_file,$in['MD5']);



        print"[".$GBL['myhostname']."] Received snort config: Saved file $destfile (".$filesize." bytes)\n";


	return;
    	}


// ************************************ Test Snort ********************************************
elseif( $in['ac'] == "test_snort" )
	{
	// *** Save the temp conf file 1st *** 
	// Get # of bytes received
	$received = strlen($in['content']);
	// Generate filename
	$destfile = $in['path'] . "/SMS_snort." . $in['int'] . ".conf.TEST"; 
	// Write the contents to the file
	WriteFile($destfile,$in['content']);

	// *** Get the # of bytes written to the file
	$filesize = filesize($destfile);

	// *** Send confirm message
	if ( $filesize == $received )
		{
		print"[".$GBL['myhostname']."] ==> Received snort temp config: Saved file $destfile (".$filesize." bytes)\n"; 
		}
	else
		{
		print"[".$GBL['myhostname']."] ==> ERROR: Receive snort temp config FAILED.\n";
		return;
		}


	$debugfile = tempnam( "/tmp", "SMS_" );
	// *** Stage the command lines    
	$command_debug = $in['snort_daemon'] . " -T -v -i " . $in['int'];
	// *** Add any arguments ***
	$command_debug .= " -c " . $in['path'] . "/SMS_snort." . $in['int'] . ".conf.TEST"; 
    	if($in['args'] != "")
		{
		$command_debug .= " " . $in['args'];
		}

	print"[".$GBL['myhostname']."] ==> Executing: $command_debug\n\n"; 

        // *** Initiate Test
        $output_debug = "";
        $cmd = "/bin/sh -c \"".$command_debug." 2>&1\"";
	$output = "";
	exec ( $cmd , $output , $result_code );
	$output_debug = implode("\n",$output);


        print"[".$GBL['myhostname']."] ==> Snort configuration test results:\n";
        print"###############################################################################\n\n";
        print $output_debug; 

	// cleanup the temp config file
	unlink($destfile);
	return;
	}

// ************************************ Start Snort ********************************************
elseif( $in['ac'] == "snort_start" )
	{
	// *** Stage the command lines    
	$command_debug 	= $in['snort_daemon'] . " -T -i " . $in['int'];
	$command_exec 	= $in['snort_daemon'] . " -D -i " . $in['int']; 
	// *** Add any arguments ***
	$command = " -c " . $in['path'] . "/SMS_snort." . $in['int'] . ".conf";
    	if($in['args'] != "")
        	{
		$command .= " " . $in['args'];
		} 
	// * Finalize commands
	$command_debug .= $command;
	$command_exec .= $command;

	// Check if snort is already running
	$temp_pid = Get_PID_from_file($GBL['snort_pidfile']);
	if($temp_pid != "")
		{
		print"[".$GBL['myhostname']."] ERROR: Snort appears to be already running - PID $temp_pid\n";
		return;
		}

	// *** Initiate Test
	$output_debug = "";
	$cmd = "/bin/sh -c \"".$command_debug." 2>&1\""; 
	$output = "";
	exec ( $cmd , $output , $result_code );
	$output_debug = implode("\n",$output);


        // check if config test passed
	if (preg_match("/ERROR/i",$output_debug))    // *** Failed config test
		{
		print"[".$GBL['myhostname']."] ERROR: Snort FAILED configuration test.\n"; 
		print $output_debug;
		return;
		}

	// *** Save command line
	$destfile = $in['path'] . "/SMS_snort." . $in['int'] . ".conf.CMD"; 
	WriteFile($destfile,$command_exec);
    
	// *** Start Snort
	$output = "";
	exec ( $command_exec , $output , $result_code );

	// Wait for snort to settle
	sleep(1);
    
	// *** Check if it's running now
	$temp_pid = Get_PID_from_file($GBL['snort_pidfile']);
	if($temp_pid == "")
		{
		print"[".$GBL['myhostname']."] ERROR: Snort FAILED to start.\n"; 
		print"[".$GBL['myhostname']."] $command_exec\n";
		return;
		}

	// If we got here, things are good.
	print"[".$GBL['myhostname']."] Snort started Successfully - PID $temp_pid\n";
	return;
	}




// ************************************ Snort Status ********************************************
elseif( $in['ac'] == "snort_status") 
	{
	// Check if Snort is running
	$temp_pid = Get_Snort_PID();
	print $temp_pid ."\n";
	return;
	}

    
// ************************************ Snort info ******************************************** 
elseif( $in['ac'] == "snort_info") 
	{
	$output_debug = "";

	// *** Show the version number and exit 
	$command_exec = $in['snort_daemon'] . " -V"; 
	$output = "";
	exec ( "/bin/sh -c \"".$command_exec. " 2>&1\"" , $output , $result_code );
	$output_debug = implode("\n",$output);

    
	print"[".$GBL['myhostname']."]\n";
	print $output_debug;
	return;
	}
    
    
// ************************************ Get Snort MD5 ******************************************** 
elseif( $in['ac'] == "snort_MD5") 
	{
	$contents = Get_Snort_MD5();
	print $contents . "\n";
	}


// ************************************ Stop Snort ******************************************** 
elseif( $in['ac'] == "snort_stop") 
	{
	// Check if snort is already running
	$temp_pid = Get_PID_from_file($GBL['snort_pidfile']);
	if($temp_pid == "")
		{
		print"[".$GBL['myhostname']."] ERROR: Cannot stop Snort. Snort doesn't appear to be running or PID file missing.\n"; 
		return;
		}

	// *** Kill the daemon
	$status = kill_via_pidfile($GBL['snort_pidfile']);

	if ($status === TRUE) 
		{
		sleep(1);
		// Check if it might still be running
		$temp_pid = Get_PID_from_file($GBL['snort_pidfile']);

		if($temp_pid != "")
 			{
			print"[".$GBL['myhostname']."] ERROR: Failed to stop Snort - PID $temp_pid\n";
			return;
			}

		
		print"[".$GBL['myhostname']."] Snort successfully stopped.\n";
		return;
		}
	else 
		{
		// failed to send signal 
		print"[".$GBL['myhostname']."] ERROR: failed to send kill signal.\n $status \n";
		return;
		}

	}

// ************************************ Restart Snort ********************************************
elseif( $in['ac'] == "snort_reset") 
	{
	// Check if snort is already running
	$temp_pid = Get_PID_from_file($GBL['snort_pidfile']);
	if($temp_pid == "")
		{
		print"[".$GBL['myhostname']."] ERROR: Cannot restart Snort. Snort doesn't appear to be running or PID file not found.\n"; 
		return;
		}

	// *** signal the daemon
	$status = kill_via_pid("-HUP", $temp_pid);

	if ($status === TRUE) 
		{
		sleep(1);
		// Check if snort is running
		$temp_pid = Get_PID_from_file($GBL['snort_pidfile']);
		if($temp_pid == "")
 			{
			print"[".$GBL['myhostname']."] ERROR: Snort died prematurly\n";
			return;
			}

		print"[".$GBL['myhostname']."] Snort successfully reset - PID ".$temp_pid.".\n";
		return;
		}
	else 
		{
		// failed to send signal 
		print"[".$GBL['myhostname']."] ERROR: failed to send reset signal.\n $status \n";
		return;
		}

	}



// ************************************ Start Barnyard ********************************************
elseif( $in['ac'] == "barn_start") 
	{
	// Stage the command line
	$command = $in['barn_daemon'] . " -D";
	$command .= " -c " . $in['path'] . "/SMS_barnyard." . $in['int'] . ".conf"; 

	// *** Add switches if they were passed ***
	if($in['sw_d'] != "")
		{ $command .= " -d " . $in['sw_d']; }
	if($in['sw_s'] != "")
		{ $command .= " -s " . $in['sw_s']; } 
	if($in['sw_f'] != "")
		{ $command .= " -f " . $in['sw_f']; }
	if($in['sw_w'] != "")
		{ $command .= " -w " . $in['sw_w']; } 
	if($in['sw_X'] != "")
		{ $command .= " -X " . $in['sw_X']; }


	// *** Save command line
	$destfile = $in['path'] . "/SMS_barnyard." . $in['int'] . ".conf.CMD"; 
	WriteFile($destfile,$command);

 	// Check if barnyard is already running 
	$temp_pid = Get_PID_from_file($GBL['barn_pidfile']);
	if($temp_pid != "")
		{
		print"[".$GBL['myhostname']."] ERROR: Barnyard appears to be already running - PID $temp_pid\n";
		return;
		}

	$output = "";
	exec ( $command , $output , $result_code );
	$output_debug = implode("\n",$output);

        # Wait for barnyard to settle
        sleep(1);

        # Check if it's running now
        $temp_pid = Get_PID_from_file($GBL['barn_pidfile']);
        if($temp_pid == "")
		{
		print"[".$GBL['myhostname']."] ERROR: Unable to confirm Barnyard start. Cannot verify PID file.\n$output_debug\n"; 
		return;
		}

	print"[".$GBL['myhostname']."] Barnyard started Successfully - PID $temp_pid\n";
	return;
	}




// ************************************ Barnyard Status ********************************************
elseif( $in['ac'] == "barn_status")
	{
	// Check if Barnyard is running 
	$temp_pid = Get_PID_from_file($GBL['barn_pidfile']);
	print $temp_pid ."\n";
	return;
	}

// ************************************ Barnyard info ********************************************
elseif( $in['ac'] == "barn_info")
	{
	$output_debug = "";

	// *** Show the version number and exit 
	$command_exec = $in['barn_daemon'] . " -V"; 
	$output = "";
	exec ( "/bin/sh -c \"".$command_exec. " 2>&1\"" , $output , $result_code );
	$output_debug = implode("\n",$output);

	print"[".$GBL['myhostname']."]\n";
	print $output_debug;
	return;
	}


// ************************************ Get Barnyard MD5 ********************************************
elseif( $in['ac'] == "barn_MD5")
	{
	$contents = Get_Barn_MD5();
	print $contents . "\n";
	return;
	}


// ************************************ Stop Barnyard ********************************************
elseif( $in['ac'] == "barn_stop")
	{
	// Check if barntard is already running
	$temp_pid = Get_PID_from_file($GBL['barn_pidfile']);
	if($temp_pid == "")
		{
		print"[".$GBL['myhostname']."] ERROR: Cannot stop Barnyard as it doesn't appear to be running or PID file not found.\n"; 
		return;
		}

	// *** Kill the daemon
	$status = kill_via_pidfile($GBL['barn_pidfile']);

	if ($status === TRUE) 
		{
		sleep(1);
		// Check if it might still be running
		$temp_pid = Get_PID_from_file($GBL['barn_pidfile']);

		if($temp_pid != "")
 			{
			print"[".$GBL['myhostname']."] ERROR: Failed to stop Barnyard - PID $temp_pid\n";
			return;
			}

		
		print"[".$GBL['myhostname']."] Barnyard successfully stopped.\n";
		return;
		}
	else 
		{
		// failed to send signal 
		print"[".$GBL['myhostname']."] ERROR: failed to send kill signal.\n $status \n";
		return;
		}

	}

// ************************************ Restart Barnyard ********************************************
elseif( $in['ac'] == "barn_reset")
	{
	// Check if barnyard is already running
	$temp_pid = Get_PID_from_file($GBL['barn_pidfile']);
	if($temp_pid == "")
		{
		print"[".$GBL['myhostname']."] ERROR: Cannot restart Barnyard as it doesn't appear to be running or PID file missing.\n"; 
		return;
		}

	// *** signal the daemon
	$status = kill_via_pid("-HUP", $temp_pid);

	if ($status === TRUE) 
		{
		sleep(1);
		// Check if snort is running
		$temp_pid = Get_PID_from_file($GBL['barn_pidfile']);
		if($temp_pid == "")
 			{
			print"[".$GBL['myhostname']."] ERROR: Barnyard died prematurly\n";
			return;
			}

		print"[".$GBL['myhostname']."] Barnyard successfully reset - PID ".$temp_pid.".\n";
		return;
		}
	else 
		{
		// failed to send signal 
		print"[".$GBL['myhostname']."] ERROR: failed to send reset signal.\n $status \n";
		return;
		}

	}



// ************************************ Save barnyard.conf ********************************************
elseif( $in['ac'] == "barn_save")
	{
	// *** Get # of bytes received
	$received = strlen($in['content']);

	// *** Generate filename
	$destfile = $in['path'] . "/SMS_barnyard." . $in['int'] . ".conf";

	// *** Write the contents to the file
	WriteFile($destfile,$in['content']);

	// *** Get the # of bytes written to the file
	$filesize = filesize($destfile);

	// *** Send confirm message
	if ( $filesize <> $received )
        	{
		print"[".$GBL['myhostname']."] ERROR: Receive barnyard config FAILED.\n";
		return;
		}

	// *** Update the MD5 checksum 
        $md5_file = $destfile . ".MD5";
	WriteFile($md5_file,$in['MD5']);
        print"[".$GBL['myhostname']."] Received barnyard config: Saved file $destfile (".$filesize." bytes)\n";

	return;
    	}


// ************************************ save sig-msg.map ******************************************** 
elseif( $in['ac'] == "save_sigmsg")
	{
	// *** Get # of bytes received
	$received = strlen($in['content']);

	// *** Generate filename
	$destfile = $in['path'] . "/SMS_sid-msg." .$in['int']. ".map"; 

	// *** Write the contents to the file
	WriteFile($destfile,$in['content']);

	// *** Get the # of bytes written to the file
	$filesize = filesize($destfile);

	// *** Send confirm message
	if ( $filesize <> $received )
        	{
		print"[".$GBL['myhostname']."] ERROR: Receive sig-msg.map - FAILED.\n";
		return;
		}

        print"[".$GBL['myhostname']."] Received sig-msg.map: Saved file $destfile (".$filesize." bytes)\n";

	return;
    	}

// ************************************ Check DB connection ******************************************** 
elseif( $in['ac'] == "check_db")
	{
	$result = Check_DB_Connection();
	print "$result\n";
	return;
	}

// ************************************ Check CPU load ******************************************** 
elseif( $in['ac'] == "check_uptime")
	{
	$result = Get_Sys_Uptime();
	print "[".$GBL['myhostname']."] $result\n";
	return;
	}

// ************************************ Check Drive Usage ******************************************** 
elseif( $in['ac'] == "check_df")
	{    
	$result = Get_Sys_df();
	print $result . "\n";
	return;
	}


# ************************************ Get All stats ********************************************
elseif( $in['ac'] == "check_all") 
	{
	$output_la = Get_Sys_Uptime();
	$output_df = Get_Sys_df();
	$output_db = Check_DB_Connection();

	$output_snort_pid = Get_PID_from_file($GBL['snort_pidfile']);
    	$output_barn_pid = Get_PID_from_file($GBL['barn_pidfile']);
	$output_snort_MD5 = Get_Snort_MD5();
	$output_barn_MD5 = Get_Barn_MD5();

	print "VR=" . $GBL['VERSION'];
	print "||"; 
	print "LA=" . $output_la;
	print "||";
	print "DF=" . $output_df;
	print "||";
	print "DB=" . $output_db;
	print "||";
	print "SP=" . $output_snort_pid; 
	print "||";
	print "BP=" . $output_barn_pid;
	print "||";
	print "S5=" . $output_snort_MD5;
	print "||";
	print "B5=" . $output_barn_MD5; 

	return;
	}




// ************************************ TEST ********************************************
elseif( $in['ac'] == "test") 
	{
	print"<CENTER>\n";
	print"<h2>SnortSMS Agent Test Page</h2>\n"; 
	$output_la = Get_Sys_Uptime();    
	print"<TABLE border=\"1\">";
	print"<TR><TD><B>Agent Version:</B></TD><TD>".$GLOBAL['VERSION']."</TD></TR>\n"; 
	print"<TR><TD><B>Host Name:</B></TD><TD>".$GBL['myhostname']."</TD></TR>\n"; 
	print"<TR><TD><B>Load Averages:</B></TD><TD>".$output_la."</TD></TR>\n";
	print"</TABLE>\n";
	print"<P>If you can read this, the agent appears to working...</P>\n"; 
	print"</CENTER>\n";
	return;
	}
else
// ************************************ !! UNKNOWN !! ********************************************
	{
	print "[".$GBL['myhostname']."] ERROR: unknown agent command -> " . $in['ac'] . "\n"; 
	return;
	}



exit(0);















/*** ######################## FUNCTIONS ########################## ***/



function GetVars(&$list)
	{
	$list = $_REQUEST;

	foreach($_FILES as $name=>$file)
		{
		if($file['error'] == 0 )
			{
			$handle = fopen($file['tmp_name'], "r");
			$list[$name] = fread($handle, filesize($file['tmp_name']));
			fclose($handle);
			}
		}
	}



function WriteFile($filename,$contents,$mode="w")
	{
	if (!$handle = fopen($filename, $mode)) 
		{
		echo "Cannot open file ($filename)";
		exit;
		}

	if (fwrite($handle, $contents) === FALSE) 
		{
		echo "Cannot write to file ($filename)";
		exit;
		}


	fclose($handle);
	}



function Get_Barn_PID()
	{
	global $in;
	$pid_file = $in['sw_X']; 
	$temp_pid = fileContents($pid_file);
	return(trim($temp_pid));
	}



function Get_Barn_MD5()
	{
	global $in;
	$filename = $in['path'] . "/SMS_barnyard." . $in['int'] . ".conf.MD5";
	$contents = fileContents($filename);
	return( $contents );
	}



function Get_PID_from_file($pid_file)
	{
	global $GBL;
	$temp_pid = fileContents($pid_file);
	return(trim($temp_pid));
	}



function kill_via_pidfile($pid_file)
	{
	$pid_id = Get_PID_from_file($pid_file);
	$status = kill_via_pid("-9",$pid_id);
	if($status === true)
		{
		unlink($pid_file);
		return(true);
		}
	return(false);
	}

function kill_via_pid($sig,$pid)
	{
	global $GBL;
	$cmd = "kill $sig $pid";
	exec($cmd, $oarr, $retval);

	if($retval == 0)
		{
		return true;
		}

	print"[".$GBL['myhostname']."] ERROR: Cannot kill pid $pid - Might not exist.\n";
	return false;
	}



function Get_Snort_MD5()
	{
	global $in;
	$filename = $in['path'] . "/SMS_snort." . $in['int'] . ".conf.MD5";
	$contents = fileContents($filename);
	return( $contents );
	}



// Returns the contents in a file
function fileContents($filename)
	{
	$contents = "";
	if(file_exists($filename))
		{

		if(!$handle = fopen($filename, "r"))
			{
			return("[$myhostname] ERROR: Cannot open $destfile");
			}

		$contents = fread($handle, filesize($filename));
		fclose($handle);

		}

	return($contents);
	}


// *** Get uptime
function Get_Sys_Uptime() 
    	{    
	$output = "";
	exec ( "uptime" , $output , $result_code );
	$results = implode("\n",$output);
	return(trim($results));
    	}

// *** Get 'df -k'
function Get_Sys_df()
	{
	$output = "";
	exec ( "df -k" , $output , $result_code );
	$results = implode("\n",$output);
	return(trim($results));
	}

// *** Check for a connection listed in 'netstat'
function Check_DB_Connection()
	{
	global $in;
	$output = 0;
	$pattern = $in['ip'] . "." . $in['port'];    
	// *** Get a netstat
	$output = "";
	exec ( "netstat -an" , $output , $result_code );
 
	// *** Loop thru and find the connection we want
	foreach($output as $line)
		{
		$line = trim($line);
        	list($proto,$rq,$sq,$local_addr,$foriegn_addr,$state) = preg_split("/\s+/",$line);    
        	if(($foriegn_addr == $pattern) && ($state == "ESTABLISHED"))
			{
			// print "MATCH!!! -> $foriegn_addr\n";
			return(1);
			}
		}

	return(0);
	}
?>
