<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

 
function GenSnortConf($sensorid,&$snort_conf,&$snort_conf_MD5)
	{
	global $db, $GBL;
	
	$hash_rulevars = array();
	$hash_varvars = array();
	$errors = "";
	
	/* Get sensor info */
	$sql = "select * FROM TBL_SENSORS WHERE id =" . $sensorid;
	$rsSensor = $db->query($sql); if (DB::isError($rsSensor)) { die ($rsSensor->getdebugInfo());}
	$row=$rsSensor->fetchRow(DB_FETCHMODE_ASSOC);
	$temp_sensorname = $row['name'];
	$temp_sensorip = $row['ip'];
	$temp_sensorport = $row['port'];
	$temp_sensoruserid = $row['userid'];
	$temp_sensorpasswd = $row['passwd'];
	$temp_sensorprotocol = $row['protocol'];
	$temp_sensorsigmsg = $row['sigmsg'];
	$temp_snort_ctrl = $row['snort_ctrl'];
	
	if($temp_snort_ctrl == "")
		{
		Stop (" You have not selected a 'Snort Control Profile' for this sensor.");
		}
		
	/* Get the snortcontrol settings */
	$sql = "SELECT * FROM TBL_SNORT_CTRL WHERE id = " . $temp_snort_ctrl;
	$rsSnortCTRL = $db->query($sql); if (DB::isError($rsSnortCTRL)) { die ($rsSnortCTRL->getdebugInfo());}
	if ($row=$rsSnortCTRL->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$temp_interface = $row['interface'];
		$temp_conf_path = $row['conf_path'];
		$rsSnortCTRL->free();
		}
	
	/* Get the variables */
	$sql = "SELECT v.* FROM TBL_ASSIGNMENTS as a, TBL_VARIABLES as v WHERE a.type = 'V' AND v.id = a.itemid AND a.sensorid =" . $sensorid . " AND v.varvalue Not Like '\\\$%' AND v.varvalue Not Like '!\\\$%' ORDER BY v.varname";
	$rsVars1 = $db->query($sql); if (DB::isError($rsVars1)) { die ($rsVars1->getdebugInfo());}
	$sql = "SELECT v.* FROM TBL_ASSIGNMENTS as a, TBL_VARIABLES as v WHERE a.type = 'V' AND v.id = a.itemid AND a.sensorid =" . $sensorid . " AND (v.varvalue Like '\\\$%' OR v.varvalue Like '!\\\$%') ORDER BY v.varname";
	$rsVars2 = $db->query($sql); if (DB::isError($rsVars2)) { die ($rsVars2->getdebugInfo());}

	/* Get the dynamics */
	$sql = "SELECT d.* FROM TBL_ASSIGNMENTS as a, TBL_DYNAMICS as d WHERE a.type = 'D' AND d.id = a.itemid AND a.sensorid =" . $sensorid . " ORDER BY d.ordr";
	$rsDyns = $db->query($sql); if (DB::isError($rsDyns)) { die ($rsDyns->getdebugInfo());}
	
	/* Get the preprocessors */
	$sql = "SELECT p.* FROM TBL_ASSIGNMENTS as a, TBL_PREPROCESSORS as p WHERE a.type = 'P' AND p.id = a.itemid AND a.sensorid =" . $sensorid . " ORDER BY p.ordr, p.preprocessor";
	$rsPres = $db->query($sql); if (DB::isError($rsPres)) { die ($rsPres->getdebugInfo());}

	/* Get the output plugins */
	$sql = "SELECT o.* FROM TBL_ASSIGNMENTS as a, TBL_OUTPUTS as o WHERE a.type = 'O' AND o.id = a.itemid AND a.sensorid =" . $sensorid . " ORDER BY o.name";
	$rsOuts = $db->query($sql); if (DB::isError($rsOuts)) { die ($rsOuts->getdebugInfo());}

	/* Get the references */
	$sql = "SELECT r.* FROM TBL_ASSIGNMENTS as a, TBL_REFERENCES as r WHERE a.type = 'R' AND r.id = a.itemid AND a.sensorid =" . $sensorid . " ORDER BY r.alias";
	$rsRefs = $db->query($sql); if (DB::isError($rsRefs)) { die ($rsRefs->getdebugInfo());}
	
	/* Get the config directives */
	$sql = "SELECT f.* FROM TBL_ASSIGNMENTS as a, TBL_CONFIGS as f WHERE a.type = 'F' AND f.id = a.itemid AND a.sensorid =" . $sensorid . " ORDER BY f.directive";
	$rsConfigs = $db->query($sql); if (DB::isError($rsConfigs)) { die ($rsConfigs->getdebugInfo());}
	
	/* Get the classifications */
	$sql = "SELECT c.* FROM TBL_ASSIGNMENTS as a, TBL_CLASSIFICATIONS as c WHERE a.type = 'C' AND c.id = a.itemid AND a.sensorid =" . $sensorid . " ORDER BY c.shortname";
	$rsClass = $db->query($sql); if (DB::isError($rsClass)) { die ($rsClass->getdebugInfo());}

	/* Get the rule types */
	$sql = "SELECT t.* FROM TBL_ASSIGNMENTS as a, TBL_RULE_TYPES as t WHERE a.type = 'X' AND t.id = a.itemid AND a.sensorid =" . $sensorid;
	$rsRTs = $db->query($sql); if (DB::isError($rsRTs)) { die ($rsRTs->getdebugInfo());}
	
	/* Incase more than one Ruletype is assign to a sensor */
	$sql_where = "(1 = 2"; /* meant to do this */
	while($row=$rsRTs->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$sql_where .= " OR a.ruletypeid = " . $row['id'];
		}
	$sql_where .= ")";

	/* Get the Ruletype Outputs */
	$sql = "SELECT t.name as rtname, t.type, o.name as outname, o.options FROM TBL_OUTPUTS as o, TBL_RULE_TYPES_OUTPUTS as a, TBL_RULE_TYPES as t WHERE a.outputid = o.id AND t.id = a.ruletypeid AND ".$sql_where." ORDER BY t.name, o.name";
	$rsRTs = $db->query($sql); if (DB::isError($rsRTs)) { die ($rsRTs->getdebugInfo());}

	/* Get the rule policies */
	$sql = "SELECT t.* FROM TBL_ASSIGNMENTS as a, TBL_POLICIES as t WHERE a.type = 'T' AND t.id = a.itemid AND a.sensorid =" . $sensorid;
	$rsPols = $db->query($sql); if (DB::isError($rsPols)) { die ($rsPols->getdebugInfo());}
	
	/* Incase more than one policy is assign to a sensor */
	$where_policies = "(1 = 2"; /* meant to do this */
	while($row=$rsPols->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$where_policies .= " OR p.policyid = " . $row['id'];
		}
	$where_policies .= ")";
	
	/* Get the rules */
	$sql = "SELECT DISTINCT r.rule, r.cata FROM TBL_RULES as r, TBL_POLICIES_RULES as p WHERE p.ruleid = r.sid AND " .$where_policies. " ORDER BY r.cata, r.sid";
	$rsRules = $db->query($sql); if (DB::isError($rsRules)) { die ($rsRules->getdebugInfo());}

	/* Get the thresholds */
	$sql = "SELECT h.* FROM TBL_ASSIGNMENTS as a, TBL_THRESHOLDS as h WHERE a.type = 'H' AND h.id = a.itemid AND a.sensorid =" . $sensorid . " ORDER BY h.gen_id, h.sig_id";
	$rsThress = $db->query($sql); if (DB::isError($rsThress)) { die ($rsThress->getdebugInfo());}

	/* Get the supressions */
	$sql = "SELECT s.* FROM TBL_ASSIGNMENTS as a, TBL_SUPPRESSIONS as s WHERE a.type = 'S' AND s.id = a.itemid AND a.sensorid =" . $sensorid . " ORDER BY s.gen_id, s.sig_id";
	$rsSuppress = $db->query($sql); if (DB::isError($rsSuppress)) { die ($rsSuppress->getdebugInfo());}
	
	/* define constants */
	$snort_conf_space = "#\n#\n#\n";
	$snort_conf_ref = "#\n#--------------------------------------------------\n# ".chr(36)."Id: references.config\n#--------------------------------------------------\n";
	
	$snort_conf_class = "#\n#--------------------------------------------------\n# ".chr(36)."Id: classification.config\n#--------------------------------------------------\n";
	$snort_conf_ftr = "#\n#\n# _EOF_\n";	
	
	$snort_conf_config = "#\n#--------------------------------------------------\n# ".chr(36)."Id: Config Directives\n#--------------------------------------------------\n";
	
	/*** Lets generate the conf file ***/
	$snort_conf = 	"#-------------------------------------------------------------------------------\n".
					"# Snort Configuration file for < ".$temp_sensorname." >\n".
					"# Generated by SnortSMS < http://sourceforge.net/projects/snortSMS/ >\n".
					"# File: SMS_snort." . $temp_interface . ".conf\n".
					"#-------------------------------------------------------------------------------\n";
	
	$snort_conf .= $snort_conf_space;
	$snort_conf .= "# [ Variables ]\n";
	while($row=$rsVars1->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$snort_conf .= "var " . $row['varname'] . " " . $row['varvalue'] . "\n";
		$hash_varvars[$row['varname']] = true;
		}
	while($row=$rsVars2->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$snort_conf .= "var " . $row['varname'] . " " . $row['varvalue'] . "\n";
		$hash_varvars[$row['varname']] = true;
		}
	
	
	$snort_conf .= $snort_conf_space;
	$snort_conf .= "# [ Dynamics ]\n";
	while($row=$rsDyns->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$snort_conf .= $row['type'] . "  " . $row['dynamic'] . "\n";
		}
	
	
	$snort_conf .= $snort_conf_space;
	$snort_conf .= "# [ Preprocessors ]\n";
	while($row=$rsPres->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$snort_conf .= "preprocessor " . $row['preprocessor'] . "\n";
		}
	
	$snort_conf .= $snort_conf_space;
	$snort_conf .= "# [ Output Plugins ]\n";
	while($row=$rsOuts->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		if ($row['options'] != "" )
			{
			$snort_conf .= "output " . $row['name'] . ": " . $row['options'] . "\n";
			}
		else
			{
			$snort_conf .= "output " . $row['name'] . "\n";
			}
		}

	/*** Draw Config Directives ***/	
	$snort_conf .= $snort_conf_config;
	while($row=$rsConfigs->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$snort_conf .= "config " . $row['directive'] . " " . $row['value'] . "\n";
		}

	/*** Draw References ***/	
	$snort_conf .= $snort_conf_ref;
	while($row=$rsRefs->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$snort_conf .= "config reference: " . $row['alias'] . " " . $row['definition'] . "\n";
		}
	
	/*** Draw Classifications ***/
	$snort_conf .= $snort_conf_class;
	while($row=$rsClass->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$snort_conf .= "config classification: " . $row['shortname'] . "," . $row['description'] . ",". $row['priority'] . "\n";
		}
	
	/*** Draw Ruletypes ***/
	$snort_conf .= $snort_conf_space;
	$snort_conf .= "# [ Ruletypes ]\n";
	$temp_cat = "";
	$temp_1st = TRUE;
	while($row=$rsRTs->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		if ($temp_cat != $row['rtname'])
			{
			$temp_cat = $row['rtname'];
			if ($temp_1st == FALSE)
				{ $snort_conf .= "    }\n"; }
			else
				{ $temp_1st = FALSE; }
	
			$snort_conf .= "ruletype $temp_cat\n    {\n";
			if ($row['type'] != NULL)
				{
				$snort_conf .= "    type " . $row['type'] . "\n";
				}
			}
		$snort_conf .= "    output ".$row['outname'] . " " . $row['options'] . "\n";
		}	
	
	if ($temp_1st == FALSE)
		{ $snort_conf .= "    }\n"; }
	
		
		
	
	/*** Draw Rules ***/
	$snort_conf .= $snort_conf_space;
	$snort_conf .= "# [ Rules ]\n";
	$temp_cat = "";
	while($row=$rsRules->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		if ($temp_cat != $row['cata'])
			{
			$temp_cat = $row['cata'];
			$snort_conf .= "#\n#--------------------------------------------------\n".
				"# ".chr(36)."Id: Exp " .$row['cata'] . ".rules ".chr(36)."\n".
				"#--------------------------------------------------\n";
			}
		$snort_conf .= $row['rule'] . "\n";
		
		/*** Remember any rule variables found in rules for later validation   ***/
		if( preg_match_all("/\\\$([a-z|A-Z|_]+)/", $row['rule'], $matches) )
			{
			foreach($matches[1] as $match)
				{
				//print"<BR>$match";
				$hash_rulevars[$match] = true;
				}			
			}
			
		}
		

	
	/*** Draw Thresholds ***/	
	$snort_conf .= "#\n#\n# [ Threshold/Supression ]\n";
	while($row=$rsThress->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$snort_conf .= "threshold gen_id ".$row['gen_id'].", sig_id ".$row['sig_id'].", type ".$row['type'].", track ".$row['track'].", count ".$row['count'].", seconds ".$row['seconds']."\n";
		}
	/*** Draw Supressions ***/	
	while($row=$rsSuppress->fetchRow(DB_FETCHMODE_ASSOC)) 
		{
		$snort_conf .= "suppress gen_id " . $row['gen_id'] . ", sig_id " . $row['sig_id'];
		if( ($row['track'] != "") && ($row['ip'] != "") )
			{
			$snort_conf .= ", track " . $row['track'] . ", ip " . $row['ip'];
			}
		$snort_conf .= "\n";
		}
	
	
	
	
	/*** Draw conf footer ***/
	$snort_conf .= $snort_conf_ftr;
	
	
	
	/*** Get MD5 Checksum ***/
	$snort_conf_MD5 = md5($snort_conf);	
	
	
	
	/*** Validation: Check if rule variables were found in the assigned vars for this config ***/
	while (list($key, $val) = each($hash_rulevars))
		{		
		if( !isset($hash_varvars[$key])  )
			{
			$errors .= "Missing variable: \$".$key."\n";	
			}
		}
	

	return($errors);
	}
	
	
	
	
	
?>
