<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

 
 function smsConnect($proto,$host,$port,$userid,$password,$formvars,&$error_num)
	{
	global $GBL;
	
	$results = "";
	$proto = strtolower($proto);

	// init curl handle
	$ch = curl_init();
	
	if ($proto == "https") {
		$proto = "https";
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE); // do not try to validate hostname on cert with ip 
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE); // don't try and validate the SSL cert
	} else {
		$proto = "http";
	}

	$submit_url = "$proto://$host:$port/agent.php";
	
	curl_setopt($ch, CURLOPT_URL, $submit_url);
	curl_setopt($ch, CURLOPT_VERBOSE, 1);
	curl_setopt($ch, CURLOPT_HEADER, false);	// don't send header
	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, false); // don't obay redirects
	curl_setopt($ch, CURLOPT_TIMEOUT, $GBL['curltimeout']);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $formvars);
	curl_setopt($ch, CURLOPT_PORT, $port);	
	curl_setopt($ch, CURLOPT_USERAGENT, "SnortSMS v.".$GBL['VERSION']);
	curl_setopt($ch, CURLOPT_USERPWD, "$userid:$password");

	/******************************************************************/
	/*
	* Lighttpd 1.4.x workaround:
	* Lighty does not handle the "Expect:" header correctly (417 error).
	* So either we not use HTTP v.1.1, or blank out the "Expect" header.
	*/
	curl_setopt($ch, CURLOPT_HTTP_VERSION, CURL_HTTP_VERSION_1_0);

	//$blah[0] = "Expect:";
	//curl_setopt($ch, CURLOPT_HTTPHEADER, $blah);

	/******************************************************************/

        if ($GBL['curlproxy'] == "1")
                {
                curl_setopt($ch, CURLOPT_PROXY, $GBL['curlproxyhost']);
                curl_setopt($ch, CURLOPT_PROXYPORT, $GBL['curlproxyport']);
                if ($GBL['curlproxyauth'] == "1")
                        {
                        curl_setopt($ch, CURLOPT_PROXYUSERPWD, $GBL['curlproxyauthuser'] . ":" . $GBL['curlproxyauthpass']);
                        }
                }

	// perform post
	$results = curl_exec($ch);
	// Any errors ??
	$error_num = curl_errno($ch);
	if($error_num <> 0)
		{
		$error = curl_error($ch);
		$results = "cURL ERROR: $error\n";
		}

	curl_close($ch); 
	return($results);
	}

function Get_curl_error($error_code)
	{
	$error_msg = "";

	/* Initialize error message array */
	$CURLERROR[1] = "Unsupported protocol. This build of curl has no support for this protocol.";
	$CURLERROR[2] = "Failed to initialize.";
	$CURLERROR[3] = "URL malformat. The syntax was not correct.";
	$CURLERROR[4] = "URL user malformatted. The user-part of the URL syntax was not correct.";
	$CURLERROR[5] = "Couldn't resolve proxy. The given proxy host could not be resolved.";
	$CURLERROR[6] = "Couldn't resolve host. The given remote host was not resolved.";
	$CURLERROR[7] = "Failed to connect to host.";
	$CURLERROR[8] = "FTP weird server reply. The server sent data curl couldn't parse.";
	$CURLERROR[9] = "FTP access denied. The server denied login.";
	$CURLERROR[10] = "FTP user/password incorrect. Either one or both were not accepted by the server.";
	$CURLERROR[11] = "FTP weird PASS reply. Curl couldn't parse the reply sent to the PASS request.";
	$CURLERROR[12] = "FTP weird USER reply. Curl couldn't parse the reply sent to the USER request.";
	$CURLERROR[13] = "FTP weird PASV reply, Curl couldn't parse the reply sent to the PASV request.";
	$CURLERROR[14] = "FTP weird 227 format. Curl couldn't parse the 227-line the server sent.";
	$CURLERROR[15] = "FTP can't get host. Couldn't resolve the host IP we got in the 227-line.";
	$CURLERROR[16] = "FTP can't reconnect. Couldn't connect to the host we got in the 227-line.";
	$CURLERROR[17] = "FTP couldn't set binary. Couldn't change transfer method to binary.";
	$CURLERROR[18] = "Partial file. Only a part of the file was transferred.";
	$CURLERROR[19] = "FTP couldn't download/access the given file, the RETR (or similar) command failed.";
	$CURLERROR[20] = "FTP write error. The transfer was reported bad by the server.";
	$CURLERROR[21] = "FTP quote error. A quote command returned error from the server.";
	$CURLERROR[22] = "HTTP page not retrieved. The requested url was not found or returned another error with the HTTP error code being 400 or above. This return code only appears if -f/--fail is used.";
	$CURLERROR[23] = "Write error. Curl couldn't write data to a local filesystem or similar.";
	$CURLERROR[24] = "Malformed user. User name badly specified.";
	$CURLERROR[25] = "FTP couldn't STOR file. The server denied the STOR operation, used for FTP uploading.";
	$CURLERROR[26] = "Read error. Various reading problems.";
	$CURLERROR[27] = "Out of memory. A memory allocation request failed.";
	$CURLERROR[28] = "Operation timeout. The specified time-out period was reached according to the conditions.";
	$CURLERROR[29] = "FTP couldn't set ASCII. The server returned an unknown reply.";
	$CURLERROR[30] = "FTP PORT failed. The PORT command failed. Not all FTP servers support the PORT command, try doing a transfer using PASV instead!";
	$CURLERROR[31] = "FTP couldn't use REST. The REST command failed. This command is used for resumed FTP transfers.";
	$CURLERROR[32] = "FTP couldn't use SIZE. The SIZE command failed. The command is an extension to the original FTP spec RFC 959.";
	$CURLERROR[33] = "HTTP range error. The range \"command\" didn't work.";
	$CURLERROR[34] = "HTTP post error. Internal post-request generation error.";
	$CURLERROR[35] = "SSL connect error. The SSL handshaking failed.";
	$CURLERROR[36] = "FTP bad download resume. Couldn't continue an earlier aborted download.";
	$CURLERROR[37] = "FILE couldn't read file. Failed to open the file. Permissions?";
	$CURLERROR[38] = "LDAP cannot bind. LDAP bind operation failed.";
	$CURLERROR[39] = "LDAP search failed.";
	$CURLERROR[40] = "Library not found. The LDAP library was not found.";
	$CURLERROR[41] = "Function not found. A required LDAP function was not found.";
	$CURLERROR[42] = "Aborted by callback. An application told curl to abort the operation.";
	$CURLERROR[43] = "Internal error. A function was called with a bad parameter.";
	$CURLERROR[44] = "Internal error. A function was called in a bad order.";
	$CURLERROR[45] = "Interface error. A specified outgoing interface could not be used.";
	$CURLERROR[46] = "Bad password entered. An error was signaled when the password was entered.";
	$CURLERROR[47] = "Too many redirects. When following redirects, curl hit the maximum amount.";
	$CURLERROR[48] = "Unknown TELNET option specified.";
	$CURLERROR[49] = "Malformed telnet option.";
	$CURLERROR[51] = "The remote peer's SSL certificate wasn't ok.";
	$CURLERROR[52] = "The server didn't reply anything, which here is considered an error.";
	$CURLERROR[53] = "SSL crypto engine not found";
	$CURLERROR[54] = "Cannot set SSL crypto engine as default";
	$CURLERROR[55] = "Failed sending network data";
	$CURLERROR[56] = "Failure in receiving network data";
	$CURLERROR[57] = "Share is in use (internal error)";
	$CURLERROR[58] = "Problem with the local certificate";
	$CURLERROR[59] = "Couldn't use specified SSL cipher";
	$CURLERROR[60] = "Problem with the CA cert (path? permission?)";
	$CURLERROR[61] = "Unrecognized transfer encoding";
	$CURLERROR[62] = "Invalid LDAP URL";
	$CURLERROR[63] = "Maximum file size exceeded";



	if(($error_code > 0) && ($error_code < 64))
		{
		$error_msg = "CURL error - " . $CURLERROR[$error_code];
		}
	

	return($error_msg);
	}


?>


