<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/*** Reformats date from an SQL format. ***/
function Date_SQL_norm ($format, $sqldate)
	{
	if($sqldate == "") { return; }
	list($date_left,$date_right) = explode(" ",$sqldate);
	list($year, $month, $day) = explode("-",$date_left);
	list($hour, $min, $sec) = explode(":",$date_right);
	$timestamp = mktime($hour, $min, $sec, $month, $day, $year);
	$newdate = strftime($format, $timestamp);
	return $newdate;
	}
	
	
/*** Returns long int (Unix seconds) from an SQL date format ***/
function Date_SQL2stamp ($sql_date)
	{
	// Split incomming times into seperate vars
	list($date_left,$date_right) = explode(" ",$sql_date);
	list($year, $month, $day) = explode("-", $date_left);
	list($hour, $min, $sec) = explode(":", $date_right);
	// Make time stamp
 	$timestamp = mktime ($hour, $min, $sec, $month, $day, $year);
	return ($timestamp);
	}



// Add or subtract from a date.
// PRECOND: Takes in Specifier, unit, date: YYYY-MM-DD HH:MM:SS
// POSTCOND: Returns the new date string: YYYY-MM-DD HH:MM:SS
function Date_SQL_math($type, $unit, $date)
    {
	// Split incomming time into seperate vars
	list($date_left,$date_right) = explode(" ",$date);
	list($year, $month, $day) = explode("-", $date_left);
	list($hour, $min, $sec) = explode(":", $date_right);
	
     // Create a time stamp so we can do math on it
	 $timestamp = mktime ($hour, $min, $sec, $month, $day, $year);
	 // Add new time
	 switch ($type)
		{
		case "d":
		$newtimestamp = $timestamp + ($unit * 60 * 60 * 24);
		break;
		

		case "H":
		$newtimestamp = $timestamp + ($unit * 60 * 60); 
		break;

		default:
		$newtimestamp = $timestamp;
		break; 
		}
		
	$newdate = strftime("%Y-%m-%d", $newtimestamp);
	return($newdate);
	}
	
	
function ShowTime($seconds)
	{
	$hours = number_format($seconds / 3600);
	$min = number_format(($seconds - ($hours * 3600)) / 60);
	$seconds = abs($seconds - ($min * 60) - ($hours * 3600));
	
	$time_string = $hours."h ".$min."m ".$seconds."s";
	return $time_string;
	}



?>