<?
/***************************************************************************
 *   Copyright (C) 2006 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

 
/* Establish a list of valid config variables */

/*** SnortSMS DB ***/
$CONF['dbhost']['section']	= "SnortSMS Database Settings";
$CONF['dbhost']['value']	= "localhost";
$CONF['dbhost']['desc']		= "Database server (IP)";

$CONF['dbname']['value']	= "SNORTSMS";
$CONF['dbname']['desc']		= "Database Name";

$CONF['dbuser']['value']	= "apache";
$CONF['dbuser']['desc']		= "Database login UserID";

$CONF['dbpasswd']['value']	= "apache";
$CONF['dbpasswd']['desc']	= "Database login password";

$CONF['dbtype']['value']	= "mysql";
$CONF['dbtype']['desc']		= "Database server type";

/*** Alert DB ***/
$CONF['dbhost_snort']['section']	= "Snort Alert Database Settings";
$CONF['dbhost_snort']['value']		= "localhost";
$CONF['dbhost_snort']['desc']		= "Database server (IP)";

$CONF['dbname_snort']['value']		= "SNORT";
$CONF['dbname_snort']['desc']		= "Database Name";

$CONF['dbuser_snort']['value']		= "apache";
$CONF['dbuser_snort']['desc']		= "Database login UserID";

$CONF['dbpasswd_snort']['value']	= "apache";
$CONF['dbpasswd_snort']['desc']		= "Database login password";

$CONF['dbtype_snort']['value']		= "mysql";
$CONF['dbtype_snort']['desc']		= "Database server type";


/*** External Programs ***/
$CONF['php_path']['section']		= "External Programs";
$CONF['php_path']['value']			= "/usr/local/bin/php";
$CONF['php_path']['desc']			= "Full path to the PHP CLI executable.";


$CONF['tar']['value']				= "/usr/bin/tar";
$CONF['tar']['desc']				= "Full path to local 'tar' command";

$CONF['tartype']['value']			= "gnu";
$CONF['tartype']['desc']			= "Local 'tar' type";
$CONF['tartype']['type']			= "input_radio";
$CONF['tartype']['options']['gnu']		= "GNU";
$CONF['tartype']['options']['other']		= "Other";


$CONF['curltimeout']['value']		= "15";
$CONF['curltimeout']['desc']		= "Curl timeout (seconds)";
$CONF['curltimeout']['size']		= "4";



$CONF['tmpdir']['section']			= "Paths";
$CONF['tmpdir']['value']			= "/var/tmp";
$CONF['tmpdir']['desc']				= "Local directory for temporary files<BR>(must be read/writable by web server)";

$CONF['log_file']['value']			= "";
$CONF['log_file']['desc']			= "SnortSMS log file: Full path and filename";



$CONF['maxrows']['section']		= "Rule Pages";
$CONF['maxrows']['value']		= "25";
$CONF['maxrows']['desc']		= "Maximum results per page";
$CONF['maxrows']['size']		= "4";

$CONF['maxpages']['value']		= "20";
$CONF['maxpages']['desc']		= "Maximum pages to pagenate";
$CONF['maxpages']['size']		= "4";


/*** Monitoring ***/
$CONF['mon_refresh']['section']		= "Monitoring";
$CONF['mon_refresh']['value']		= "180";
$CONF['mon_refresh']['desc']		= "Monitor Console refresh rate (seconds).";
$CONF['mon_refresh']['size']		= "4";

$CONF['mon_la_critical']['value']	= "4.5";
$CONF['mon_la_critical']['desc']	= "CPU Utilization - Critical threshold.";
$CONF['mon_la_critical']['size']	= "6";

$CONF['mon_la_warning']['value']	= "2.5";
$CONF['mon_la_warning']['desc']		= "CPU Utilization - Warning threshold.";
$CONF['mon_la_warning']['size']		= "6";

$CONF['mon_hdd_critical']['value']	= "99";
$CONF['mon_hdd_critical']['desc']	= "Disk Capacity (%) - Critical threshold.";
$CONF['mon_hdd_critical']['size']	= "6";

$CONF['mon_hdd_warning']['value']	= "80";
$CONF['mon_hdd_warning']['desc']	= "Disk Capacity (%) - Warning threshold.";
$CONF['mon_hdd_warning']['size']	= "6";

$CONF['mon_db_server_ip']['section']	= "Monitoring (DB-Feed)";
$CONF['mon_db_server_ip']['value']		= "127.0.0.1";
$CONF['mon_db_server_ip']['desc']		= "Enter the 'IP' to the Snort database server.";

$CONF['mon_db_server_port']['value']	= "3306";
$CONF['mon_db_server_port']['desc']		= "Enter the 'port' to the Snort database server.";
$CONF['mon_db_server_port']['size']		= "6";



/*** Http Proxy Support ***/
$CONF['curlproxy']['section']		= "HTTP Proxy";
$CONF['curlproxy']['value']		= "0";
$CONF['curlproxy']['desc']		= "Use HTTP Proxy";
$CONF['curlproxy']['type']		= "input_radio";
$CONF['curlproxy']['options']['0']	= "No";
$CONF['curlproxy']['options']['1']	= "Yes";

$CONF['curlproxyhost']['value']		= "localhost";
$CONF['curlproxyhost']['desc']		= "HTTP Proxy Host";

$CONF['curlproxyport']['value']		= "8080";
$CONF['curlproxyport']['desc']		= "HTTP Proxy Port";
$CONF['curlproxyport']['size']		= "4";

$CONF['curlproxyauth']['value']		= "0";
$CONF['curlproxyauth']['desc']		= "Use HTTP Proxy Authentication";
$CONF['curlproxyauth']['size']		= "1";
$CONF['curlproxyauth']['type']		= "input_radio";
$CONF['curlproxyauth']['options']['0']	= "No";
$CONF['curlproxyauth']['options']['1']	= "Yes";

$CONF['curlproxyauthuser']['value']	= "";
$CONF['curlproxyauthuser']['desc']	= "HTTP Proxy Username";

$CONF['curlproxyauthpass']['value']	= "";
$CONF['curlproxyauthpass']['type']	= "input_password";
$CONF['curlproxyauthpass']['desc']	= "HTTP Proxy Password";



/*** Read Default settings into $GBL ***/
foreach ($CONF as $key => $value)
	{
	$GBL[$key] = $CONF[$key]['value'];
	}


?>
