<p align="center"><span class="heading">Snort Event Search</span></p>
<p>Allows you to search the Snort Event database for alerts matching specific criteria. See below for supported criteria:</p>

<p><B>Time Range:</B> (optional)<BR>
Narrows your search to a specific time window.<BR>
Format YYYY-MM-DD HH:MM:SS</p>

<P>One of the following is required:</P>

<p><B>Keyword:</B><BR>
This can be a string or keyword pattern of characters to search on. This is applied to the Event name and the payload data. Note: payload data matches are case sensitive.</p>

<p><B>IP or CIDR:</B><BR>
Must be a valid IP address (no partials). Will search either source or destination IP address. Also supports CIDR network notation (i.e. 192.168.1.0/24) for searching IP ranges.</p>

<p><B>Port:</B><BR>
Must be a valid port number. Will search either source or destination port.</p>


<p align="center"><span class="heading">- FAQ -</span></p>

<p><span class="heading">Q:</span> <u>Can you speed up the search queries</u>?<br>
<span class="heading">A:</span> We have optumized the search functions. Snort's Event database structure is 'normalized' to reduce data redundancy thus save storage space. Unfortunatally, this causes a performance draw-back when querying data in that the records must be re-assembled (table joins) from serveral related tables. Since table joins can be very resource expensive, we have opted to querying each table seperately and letting php re-assemble the data in RAM, which has contributed to significant speed increases.</p>

<p><span class="heading">Q:</span> <u>How do I assocciate 'tagged packets' to the original Event</u>?<br>
<span class="heading">A:</span> Unfortunatally this is not something SnortSMS can solve. Currently, the Snort Event database schema doesn't provide a way to link tagged events to the triggering event. This is also partly due to Snort and/or Barnyard not sending any assocciative data to correlate tagged events.</p>
