<p align="center"><span class="heading">Sensor Configuration</span></p>
<p>This is a configuration form that allows you to create, configure, and monitor your sensors. Each sensor is considered an interface which means multiple sensors can exist on one system (if it has multiple network interfaces to monitor). This section is broken up into multiple 'tabs':</p>

<p align="center"><B>Sensor</B> tab</P>

<p><span class="label">Sensor:</span><BR>
Any friendly/descriptive name to represent your sensor configuration.</p>

<p><span class="label">Enabled:</span><BR>
If unchecked, will removed the sensor from the Monitoring Console. Usefull if the sensor is temporarally removed or offline.</p>

<p align="center"><B>Remote Agent</B> tab</P>

<p>These will mostly mirror your remote Webmin settings.<BR>Note: Be sure to 'Disable session authentication' in your Webmin Authentication section or else SnortSMS will not be able to establish a connection to Webmin.</p>

<p><span class="label">Agent IP Address:</span><BR>
Enter the IP address of your Webmin server where the SnortSMS Agent listner is installed on.</p>

<p><span class="label">Agent Port:</span><BR>
Enter the port number of your Webmin server where the SnortSMS Agent listner is installed on.</p>

<p><span class="label">Protocol:</span><BR>
Set the HTTP protocol of your Webmin server.</p>

<p><span class="label">Agent UserID:</span><BR>
The Webmin user name that SnortSMS can remotely connect as.</p>

<p><span class="label">Password:</span><BR>
The Webmin password for the user name that SnortSMS can remotely connect as.</p>



<p align="center"><B>Snort Config</B> tab</P>

<p><span class="label">Snort Daemon Profile:</span><BR>
Select the Daemon Profile that will properly control the Snort Daemon process.</p>

<p><span class="label">Push sig-msg map:</span><BR>
If you are using Barnyard to send Alerts to a central database, choose 'Yes' as this will make sure barnyard has an updated signature ID to Signature Name coorelation map. Otherwise, you may get alerts missing there cononicle names in the database.</p>

<p><span class="label">Snort Sub Categories</span><BR>
These categories corespond to the sections within the Snort configuration file. Simply click on the 'pick' link to drag options into your sensor's config.</p>



<p align="center"><B>Barnyard Config</B> tab</P>

<p><span class="label">Barnyard Daemon Profile:</span><BR>
Select the Daemon Profile that will properly control the Barnyard Daemon process.</p>

<p><span class="label">Barnyard Sub Categories</span><BR>
contains the Barnyard configuration.</p>



<p align="center"><B>Status</B> tab</P>

<p>Helps with getting useful status and health information from the sensor.</p>

<p><span class="label">SMS Agent</span><BR>
Displays if and when the last connection was made to the sensor.<BR>
Green = successful<BR>
Red = Failed connection</p>

<p><span class="label">CPU Utilization</span><BR>
Indicates the latest load average on the sensor. Threshold settings can be customized in the 'Global Setting' section.<BR>
Green = Within specification<BR>
Yellow = Warning - higher than normal load<BR>
Red = Critical - Above the allowed threshold</p>

<p><span class="label">Storage</span><BR>
Indicates the latest disk capacity on each partition. Threshold settings can be customized in the 'Global Setting' section.<BR>
Green = Within specification<BR>
Yellow = Warning - higher than expected capacity<BR>
Red = Critical - Above the allowed threshold</p>

<p><span class="label">Snort</span><BR>
Indicates Snort daemon and configuration status. Threshold settings can be customized in the 'Global Setting' section.<BR>
Daemon Green = Snort is running<BR>
Daemon Red = Failed to detect snort running<BR>
Config Green = Remote Snort config file matches current SnortSMS settings<BR>
Config Red = Remote Snort config file doesn't match the current SnortSMS settings<BR>
</p>

<p><span class="label">Barnyard</span> (optional)<BR>
Indicates Barnyard daemon and configuration status. Threshold settings can be customized in the 'Global Setting' section.<BR>
Daemon Green = Barnyard is running<BR>
Daemon Red = Failed to detect Barnyard running<BR>
Config Green = Remote Barnyard config file matches current SnortSMS settings<BR>
Config Red = Remote Barnyard config file doesn't match the current SnortSMS settings<BR>
</p>

<p><span class="label">Database Feed</span> (optional)<BR>
Indicates the tcp database connection. If you are using Barnyard to connect to your database, this indication may only serve informational as Barnyard can automatically recover the connection when needed. Note: be sure to properly configure Database Feed monitoring in the 'Global Setting' section.<BR>
Green = Established connection<BR>
Yellow = No connection found<BR>
</p>


<p align="center"><span class="heading">- FAQ -</span></p>
<p><span class="heading">Q:</span> <u>-</u>.<br>
<span class="heading">A:</span> -</p>


