<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

include_once("conf/act_init_vars.php");
include_once("conf/conf.php");
include_once("FMK_lib/func_GenBarnConf.php");
include_once("FMK_lib/func_GenSnortConf.php");
include_once("FMK_lib/func_curl_error.php");
include_once("FMK_lib/func_ReserveNextID.php");
include_once("FMK_lib/func_Log.php");

$response = "";
$reply = "";
$connected = "0";
$db_feed = "-1";
$snort_pid = "-1";
$snort_sync = "-1";
$barn_pid = "-1";
$barn_sync = "-1";
$mon_uptime = "";
$mon_df = "";

/*** Include PEAR DB wrapper functions ***/
require_once( "DB.php" );

/*** Open Persistant Database Conection ***/
$GBL["dbdsn"] = $GBL["dbtype"] . "://" . $GBL["dbuser"] . ":" . $GBL["dbpasswd"] . "@" . $GBL["dbhost"] . "/" . $GBL["dbname"];	// DSN String
$db = DB::connect($GBL["dbdsn"],false); if (DB::isError($db)) { die ($db->getMessage());}


/*** Get the sensor ID number ***/
$sensorid = $_SERVER['argv'][1];
//print "Sensor = ".$sensorid."\n";


/*** Clear the connection bit in monitor cache DB ***/
Reset_Connect_Status($sensorid,"0");

/*** Get Sensor details ***/
$sql = "select s.*, sc.*, bc.* FROM TBL_SENSORS as s".
	" LEFT JOIN TBL_SNORT_CTRL as sc ON s.snort_ctrl=sc.id".
	" LEFT JOIN TBL_BARN_CTRL as bc ON s.barn_ctrl=bc.id".
	" WHERE s.id =" . $sensorid;
$rsSensorCTRL = $db->query($sql); if (DB::isError($rsSensorCTRL)) { die ($rsSensorCTRL->getdebugInfo());}
$row = $rsSensorCTRL->fetchRow(DB_FETCHMODE_ASSOC);		
$temp_method 		= ($row['protocol'] == 1 ? "https" : "http" );
$temp_name 			= $row['name'];
$temp_active 		= ($row['active'] == 1 ? "checked" : ""  );
$temp_ip 			= $row['ip'];	
$temp_port 			= $row['port'];
$temp_userid 		= $row['userid'];
$temp_passwd 		= $row['passwd'];
$temp_int 			= $row['interface'];
$temp_conf_path 	= $row['conf_path'];
$temp_switch_X		= $row['switch_X'];
$rsSensorCTRL->free();



/*** Prep the POST data ***/	
$postVars = array();
$postVars['ac'] 			= "check_all";
$postVars['int'] 			= $temp_int;
$postVars['path'] 			= $temp_conf_path;
$postVars['ip'] 			= $GBL['mon_db_server_ip'];
$postVars['port'] 			= $GBL['mon_db_server_port'];
if($temp_switch_X != "") {
	$postVars['sw_X'] 		= $temp_switch_X;
}

/*** Initiate Connection ***/
$resultcode = "";
$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);

//var_dump($output);


if($resultcode != 0)
	{
	$response = "[SnortSMS] $output\n";
	LogEvent("Sensor Query[$sensorid]: response: $response");		
	}
else
	{
	$connected = 1;
	/*** concat all sensor output lines and create an array of response codes ***/
	$reply .= $output;
	$lines = explode("||",$reply);
	foreach($lines as $item)
		{
		//print "ITEM: ". $item . "\n";
		list($key,$value) = explode("=",$item);
		$rcodes[$key] = $value;		
		}
	//print_r($rcodes);
	
	$bytes = strlen($reply);
	LogEvent("Sensor Query[$sensorid]: response: $bytes bytes");	
	
	/*** Asses Remote Agent Version ***/
	$agent_ver = "";
	if(isset($rcodes['VR']))
		{ $agent_ver = $rcodes['VR']; }

	/*** Asses Snort running ***/
	if($rcodes['SP'] >= 1)
		{ $snort_pid = $rcodes['SP']; }
	else
		{ $snort_pid = "0"; }	
	
	/*** Asses Snort config file ***/
	$rcodes['S5'] = chop($rcodes['S5']);
	GenSnortConf($sensorid, $snort_conf, $snortsms_MD5);	
	if($rcodes['S5'] == $snortsms_MD5)
		{ $snort_sync = 1; }
	else
		{ $snort_sync = 0; }
	
	/*** Asses Barnyard running ***/
	if($rcodes['BP'] >= 1)
		{ $barn_pid = $rcodes['BP']; }
	else
		{ $barn_pid = "0"; }
	
	/*** Asses Barnyard config file ***/
	$rcodes['B5'] = chop($rcodes['B5']);
	GenBarnConf($sensorid, $barn_conf, $snortsms_barn_MD5);
	if($rcodes['B5'] == $snortsms_barn_MD5)
		{ $barn_sync = 1; }
	else
		{ $barn_sync = 0; }	
	
	
	/*** Asses database feed ***/
	if($rcodes['DB'] == "1")
		{ $db_feed = 1; }
	else
		{ $db_feed = 0; }
	
	/*** Get uptime info ***/
	if (preg_match("/load/", $rcodes['LA'], $matches))
		{ $mon_uptime = $rcodes['LA']; }
	
	/*** Get partition info ***/
	if (preg_match("/Mounted/", $rcodes['DF'], $matches))
		{ $mon_df = $rcodes['DF']; }
	
	
	
	
	}



	
	
/*** Update the Monitor Cache ***/
$sql =	"UPDATE	TBL_SENSORS ".
"SET ".
"mon_snortproc = '$snort_pid', ".
"mon_snortsync = '$snort_sync', ".
"mon_barnproc = '$barn_pid', ".
"mon_barnsync = '$barn_sync', ".
"mon_db = '$db_feed', ".
"mon_uptime = '$mon_uptime', ".
"mon_df = '".mysql_escape_string($mon_df)."', ".
"mon_stamp = '".gmdate("Y-m-d H:i:s")."', ".
"mon_ver = '$agent_ver', ".
"mon_connect = '$connected' ".
"WHERE id = ".$sensorid;	

$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
	
	
	
	
	
	
	
	
print $response;
exit(0);
	


	
?>