<?
/***************************************************************************
 *   Copyright (C) 2005 by J Randolph Smith                                *
 *   snortsms@servangle.net                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

include_once("conf/conf.php");
include_once("FMK_lib/func_GenBarnConf.php");
include_once("FMK_lib/func_GenSnortConf.php");
include_once("FMK_lib/func_curl_error.php");
include_once("FMK_lib/func_GenToken.php");
include_once("FMK_lib/func_gen_sid-msg.php");
include_once("FMK_lib/func_ReserveNextID.php");
require_once("FMK_lib/func_Log.php");

$response = "";
$reply = "";
$connected = "0";



/*** Include PEAR DB wrapper functions ***/
require_once( "DB.php" );

/*** Open Persistant Database Conection ***/
$GBL["dbdsn"] = $GBL["dbtype"] . "://" . $GBL["dbuser"] . ":" . $GBL["dbpasswd"] . "@" . $GBL["dbhost"] . "/" . $GBL["dbname"];	// DSN String
$db = DB::connect($GBL["dbdsn"],false); if (DB::isError($db)) { die ($db->getMessage());}


/*** Get the sensor ID number ***/
$sensorid = $_SERVER['argv'][1];
$action = $_SERVER['argv'][2];
//print "Sensor = ".$sensorid."\n";


/*** Clear the connection bit in monitor cache DB ***/
Reset_Connect_Status($sensorid,"0");

/*** Get Sensor details ***/
$sql = "select s.*, sc.*, bc.* FROM TBL_SENSORS as s".
	" LEFT JOIN TBL_SNORT_CTRL as sc ON s.snort_ctrl=sc.id".
	" LEFT JOIN TBL_BARN_CTRL as bc ON s.barn_ctrl=bc.id".
	" WHERE s.id =" . $sensorid;
$rsSensorCTRL = $db->query($sql); if (DB::isError($rsSensorCTRL)) { die ($rsSensorCTRL->getdebugInfo());}
$row = $rsSensorCTRL->fetchRow(DB_FETCHMODE_ASSOC);		
$temp_method 		= ($row['protocol'] == 1 ? "https" : "http" );
$temp_name 			= $row['name'];
$temp_active 		= ($row['active'] == 1 ? "checked" : ""  );
$temp_ip 			= $row['ip'];	
$temp_port 			= $row['port'];
$temp_userid 		= $row['userid'];
$temp_passwd 		= $row['passwd'];
$temp_int 			= $row['interface'];
$temp_snortdaemon	= $row['snortdaemon'];
$temp_conf_path 	= $row['conf_path'];
$temp_interface		= $row['interface'];
$temp_conf_path		= $row['conf_path'];
$temp_sensorsigmsg	= $row['sigmsg'];
$temp_snort_args	= $row['snort_args'];
$temp_barndaemon	= $row['barndaemon'];
$temp_switch_d 		= $row['switch_d'];
$temp_switch_f 		= $row['switch_f'];
$temp_switch_w 		= $row['switch_w'];
$temp_barn_args 	= $row['args'];
$temp_switch_X 		= $row['switch_X'];



$rsSensorCTRL->free();



LogEvent("Sensor Control[$sensorid]: action: $action");


/*** ############################################ Snort Test ***/
if($action == "snort_test")
	{
	GenSnortConf($sensorid,$snort_conf,$snort_conf_MD5);
		
	/*** Dump snort file to a temp file ***/
	$filename = "/tmp/snortsms_" . GenToken(12) . ".tmp";
	$handle = fopen($filename, "a");
	fwrite($handle,$snort_conf);
	fclose($handle);

	/*** Prep the POST data ***/	
	$postVars = array();
	$postVars['ac'] 			= "test_snort";
	$postVars['snort_daemon'] 	= $temp_snortdaemon;
	$postVars['int'] 			= $temp_int; 
	$postVars['path'] 			= $temp_conf_path;
	$postVars['content'] 		= "@".$filename;
	/* Add switches if not empty */
	if($temp_snort_args != "")
		{
		$postVars['args'] = $temp_snort_args;
		}

	/*** Initiate Connection ***/
	$resultcode = "";
	$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
	unlink($filename);
	
	if($resultcode != 0)
		{
		$curl_msg = Get_curl_error($resultcode);
		$response = "[SnortSMS] $output\n";	
		}
	else
		{
		$connected = 1;
		$response = $output;
		}
	//print $command . "<BR>". $response;exit(1);

	}
/*** ############################################ Snort Start ***/
elseif($action == "snort_start")
	{
	/*** Prep the POST data ***/	
	$postVars = array();
	$postVars['ac'] 			= "snort_start";
	$postVars['snort_daemon'] 	= $temp_snortdaemon;
	$postVars['int'] 			= $temp_int;
	$postVars['path'] 			= $temp_conf_path;
	/* Add switches if not empty */
	if($temp_snort_args != "")
		{
		$postVars['args'] = $temp_snort_args;
		}

	/*** Initiate Connection ***/
	$resultcode = "";
	$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
	
	if($resultcode != 0)
		{
		$response = "[SnortSMS] $output\n";	
		}
	else
		{
		$connected = 1;
		$response = $output;
		
		/*** Check if Snort was actually started and log it's PID ***/
		if (preg_match("/Successfully[^P]+PID\s(\d+)/", $response, $matches))
			{
			$snort_pid = $matches[1];
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".
			"mon_connect = '1', ".
			"mon_snortproc = '$snort_pid' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		
		}


	}
/*** ############################################ Snort Stop ***/
elseif($action == "snort_stop")
	{
	/*** Prep the POST data ***/	
	$postVars = array();
	$postVars['ac'] 	= "snort_stop";
	$postVars['int'] 	= $temp_int;
	
	/*** Initiate Connection ***/
	$resultcode = "";
	$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
	
	if($resultcode != 0)
		{
		$response = "[SnortSMS] $output\n";	
		}
	else
		{
		$connected = 1;
		$response = $output;
		
		/*** Check if Barnyard was actually Stopped ***/
		if (preg_match("/Snort successfully stopped/", $response, $matches))
			{
			$snort_pid = "0";
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".
			"mon_connect = '1', ".
			"mon_snortproc = '$snort_pid' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		}
	}
	
/*** ############################################ Snort Reset ***/
elseif($action == "snort_reset")
	{
	/*** Prep the POST data ***/	
	$postVars = array();
	$postVars['ac'] 	= "snort_reset";
	$postVars['int'] 	= $temp_int;
	
	/*** Initiate Connection ***/
	$resultcode = "";
	$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
	
	if($resultcode != 0)
		{
		$response = "[SnortSMS] $output\n";	
		}
	else
		{
		$connected = 1;
		$response = $output;
		}
	}
	
/*** ############################################ Snort Info ***/
elseif($action == "snort_info")
	{
	/*** Prep the POST data ***/	
	$postVars = array();
	$postVars['ac'] 			= "snort_info";
	$postVars['snort_daemon'] 	= $temp_snortdaemon;
	
	/*** Initiate Connection ***/
	$resultcode = "";
	$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
	
	if($resultcode != 0)
		{
		$response = "[SnortSMS] $output\n";	
		}
	else
		{
		$connected = 1;
		$response = $output;
		}	
	}

/*** ############################################ Snort Push ***/
elseif($action == "snort_push")
	{
	GenSnortConf($sensorid,$snort_conf,$snort_conf_MD5);
		
	/*** Dump snort file to a temp file ***/
	$filename = "/tmp/snortsms_" . GenToken(12) . ".tmp";
	$handle = fopen($filename, "a");
	fwrite($handle,$snort_conf);
	fclose($handle);

	/*** Prep the POST data ***/	
	$postVars = array();
	$postVars['ac'] 			= "save_snort";
	$postVars['int'] 			= $temp_interface;
	$postVars['path'] 			= $temp_conf_path;
	$postVars['MD5'] 			= $snort_conf_MD5;
	$postVars['content'] 		= "@".$filename;

	/*** Initiate Connection ***/
	$resultcode = "";
	$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
	unlink($filename);
	
	if($resultcode != 0)
		{
		$response = "[SnortSMS] $output\n";	
		}
	else
		{
		$connected = 1;
		$response = $output;

		/*** Check if Snort config was actually push ***/
		if (preg_match("/Push snort config Successful/", $response, $matches))
			{
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".	
			"mon_snortsync = '1', ".
			"mon_connect = '1' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		}

	/*** sig-msg map support ***/
	if ( $temp_sensorsigmsg == 1 )
		{
		$sig_msg_map = Gen_sid_msg($sensorid);
		/*** Dump file to a temp file ***/
		$filename = "/tmp/snortsms_" . GenToken(12) . ".tmp";
		$handle = fopen($filename, "a");
		fwrite($handle,$sig_msg_map);
		fclose($handle);
	
		/*** Prep the POST data ***/	
		$postVars = array();
		$postVars['ac'] 			= "save_sigmsg";
		$postVars['int'] 			= $temp_interface;
		$postVars['path'] 			= $temp_conf_path;
		$postVars['content'] 		= "@".$filename;
		
		/*** Initiate Connection ***/
		$resultcode = "";
		$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
		unlink($filename);
		
		if($resultcode != 0)
			{
			$response = "[SnortSMS] $output\n";	
			}
		else
			{
			$connected = 1;
			$response .= $output; 
			}
		}

	
	}

/*** ############################################ Barn Start ***/
elseif($action == "barn_start")
	{
	/*** Prep the POST data ***/	
	$postVars = array();
	$postVars['ac'] 		= "barn_start";
	$postVars['barn_daemon'] 	= $temp_barndaemon;
	$postVars['int'] 		= $temp_int;
	$postVars['path'] 		= $temp_conf_path;
	$postVars['sw_s'] 		= $temp_conf_path."/SMS_sid-msg.".$temp_int.".map";
	if($temp_switch_d != "") {
		$postVars['sw_d'] 	= $temp_switch_d;
	}
	if($temp_switch_f != "") {
		$postVars['sw_f'] 	= $temp_switch_f;
	}
	if($temp_switch_w != "") {
		$postVars['sw_w'] 	= $temp_switch_w;
	}
	if($temp_barn_args != "") {
		$postVars['args'] 	= $temp_barn_args;
	}
	if($temp_switch_X != "") {
		$postVars['sw_X'] 	= $temp_switch_X;
	}

	/*** Initiate Connection ***/
	$resultcode = "";
	$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
	
	if($resultcode != 0)
		{
		$response = "[SnortSMS] $output\n";	
		}
	else
		{
		$connected = 1;
		$response = $output;		
		
		/*** Check if Barnyard was actually started and record the PID ***/
		if (preg_match("/Successfully[^P]+PID\s(\d+)/", $response, $matches))
			{
			$barn_pid = $matches[1];
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".
			"mon_connect = '1', ".
			"mon_barnproc = '$barn_pid' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		}
	}
	
/*** ############################################ Barn Stop ***/
elseif($action == "barn_stop")
	{
	/*** Prep the POST data ***/	
	$postVars = array();
	$postVars['ac'] 			= "barn_stop";
	$postVars['int'] 			= $temp_int;
	if($temp_switch_X != "") {
		$postVars['sw_X'] 		= $temp_switch_X;
	}
	
	/*** Initiate Connection ***/
	$resultcode = "";
	$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
	
	if($resultcode != 0)
		{
		$response = "[SnortSMS] $output\n";	
		}
	else
		{
		$connected = 1;
		$response = $output;
			
		/*** Check if Barnyard was actually Stopped ***/
		if (preg_match("/Barnyard successfully stopped/", $response, $matches))
			{
			$barn_pid = "0";
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".
			"mon_connect = '1', ".
			"mon_barnproc = '$barn_pid' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		}
	}
	
/*** ############################################ Barn Reset ***/
elseif($action == "barn_reset")
	{
	/*** Prep the POST data ***/	
	$postVars = array();
	$postVars['ac'] 			= "barn_reset";
	$postVars['int'] 			= $temp_int;
	if($temp_switch_X != "") {
		$postVars['sw_X'] 		= $temp_switch_X;
	}
	
	/*** Initiate Connection ***/
	$resultcode = "";
	$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
	
	if($resultcode != 0)
		{
		$response = "[SnortSMS] $output\n";	
		}
	else
		{
		$connected = 1;
		$response = $output;
		}
	}
	
/*** ############################################ Barn Info ***/
elseif($action == "barn_info")
	{
	/*** Prep the POST data ***/	
	$postVars = array();
	$postVars['ac'] 			= "barn_info";
	$postVars['barn_daemon'] 	= $temp_barndaemon;
	
	/*** Initiate Connection ***/
	$resultcode = "";
	$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
	
	if($resultcode != 0)
		{
		$response = "[SnortSMS] $output\n";	
		}
	else
		{
		$connected = 1;
		$response = $output;
		}
	}
	
/*** ############################################ Barn Push ***/
elseif($action == "barn_push")
	{
	GenBarnConf($sensorid,$barn_conf,$barn_conf_MD5);
	
	/*** Dump barn file to a temp file ***/
	$tempfile = "/tmp/snortsms_" . GenToken(12) . ".tmp";
	$handle = fopen($tempfile, "a");
	fwrite($handle,$barn_conf);
	fclose($handle);
	
	/*** Prep the POST data ***/	
	$postVars = array();
	$postVars['ac'] 			= "barn_save";
	$postVars['path'] 			= $temp_conf_path;
	$postVars['int'] 			= $temp_interface;
	$postVars['MD5'] 			= $barn_conf_MD5;
	$postVars['content'] 		= "@".$tempfile;

	/*** Initiate Connection ***/
	$resultcode = "";
	$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
	unlink($tempfile);
	
	if($resultcode != 0)
		{
		$response = "[SnortSMS] $output\n";	
		}
	else
		{
		$connected = 1;
		$response = $output;
	
		/*** Check if Barnyard config was actually push ***/
		if (preg_match("/Push barnyard config Successful/", $response, $matches))
			{
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".	
			"mon_barnsync = '1' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}
		}
	
	}
/*** ############################################ System Load Averages ***/
elseif($action == "check_uptime")
	{
	/*** Prep the POST data ***/	
	$postVars = array();
	$postVars['ac'] 			= "check_uptime";
	
	/*** Initiate Connection ***/
	$resultcode = "";
	$output = smsConnect($temp_method,$temp_ip,$temp_port,$temp_userid,$temp_passwd,$postVars,$resultcode);
	
	if($resultcode != 0)
		{
		$response = "[SnortSMS] $output\n";	
		}
	else
		{
		$connected = 1;
		$response = $output;		
		
		/*** Get uptime info ***/
		if (preg_match("/load/", $response, $matches))
			{ 
			$mon_uptime = $response;
			
			/* Update the Monitor cache */
			$sql =	"UPDATE	TBL_SENSORS ".
			"SET ".
			"mon_uptime = '".$mon_uptime."' ".
			"WHERE id = ".$sensorid;	
			$result = $db->query($sql); if (DB::isError($result)) { die ($result->getdebugInfo());}
			}

		}	
	}
	
	
	
	
	
	
	
	
	
	
	
/*** Restore the connection bit in monitor cache DB ***/
Reset_Connect_Status($sensorid,$connected);
	
	
LogEvent("Sensor Control[$sensorid]: response: $response");
	
print $response;
exit(0);
	


	
?>